# -*- coding: utf-8 -*-
"""
Created on Sun Feb  7 11:21:31 2021

@author: alpko
"""
#Data Extraction

#import all necessary libraries.
import itertools
import math
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt

""" IMPORTANT: Please delete the first two lines (strings) from the text file, otherwise the code will not run!!! """

#Set the number of rows and columns to display by the dataframe object
pd.set_option("display.max_rows", 10, "display.max_columns", 6)

#Include the names of the columns accordingly.
names = ['TIME', 'Rhein_upstream_(Fm780900)','Rhein_mid0_(Fm789600)', 'Rhein_mid_(Fm798300)', 'Rhein_mid2_(Fm807600)', 'Rhein_wesel_(Fm813800)', 'DYKE_BREACH802000']

#Read the file and parse it to a string object. 
"""PUT YOUR CONTROL SECTION OUTPUT FILE'S DESTINATION TO THE LINE BELOW"""
with open(r"put_your_file_destination_here\control_sections_output.txt") as f:
  content = f.readlines()
  res = ''
  for i in itertools.islice(content, 0, len(content), 2), itertools.islice(content,1,len(content),2):
    res += ' '.join(i)
    
    #Separate the results by splitting them to two different sets.
l = res.split('\n')

#Create panda series and modify the indexes so that column names can be added afterwards.
arr = pd.Series(l)
a = pd.Series(arr[:math.floor(arr.size / 2)])
b = pd.Series(arr[math.floor(arr.size / 2):arr.size-1])

#Need to reset the indexes so that the series can be joined together.
b = b.reset_index(drop = True)

#Split the values to create a joined time series.
c = a.str.split(expand = True)
d = b.str.split(expand = True)

#Rename the columns accordingly to their indexes and join the series.
c.columns=names[:len(c.columns)]
d.columns = names[len(c.columns):len(names)]
final = c.join(d)

#Make the values inside the dataframe to be numeric
final = final.apply(pd.to_numeric)

#Conjoined graphs.
plt.figure();
final.plot(x="TIME");

#Export the series as a dataframe
final.to_csv(header=True)